package simulator;
import java.util.concurrent.*;

public class Message implements Delayed {
	public static final int MESSAGETYPES = 10;
	
	/* Pre-determined message types */
	
	public static final int PING = 1;
	public static final int PONG = 2;
	public static final int LOOKUP =3;
	
	private int destination;
	
	public int type;
	public String field1;
	public int field2;
	public int field3;
	
	private long endOfDelay;
	
	public Message(int destination) {
		this.destination = destination;
	}
	
	public void setDelay(long delay) {
		endOfDelay = delay + System.currentTimeMillis();
	}
	
	public Message(int destination, long delay) {
		this.destination = destination;
		endOfDelay = delay + System.currentTimeMillis();
	}
	
	
	public long getDelay(TimeUnit timeUnit) {
	    return timeUnit.convert(endOfDelay - System.currentTimeMillis(),
	    		TimeUnit.MILLISECONDS);
	}
	
	public int compareTo(Delayed delayed) {
	    Message other = (Message)delayed;
		
		if (this.endOfDelay < other.endOfDelay)
			return -1;
		if (this.endOfDelay > other.endOfDelay)
			return 1;
		return 0;
	}
	
	public int getDestination() {
		return destination;
	}
	
}
